/*
 * Sablotron - XSL processor
 * Copyright (C) 2000 Ginger Alliance Ltd.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef ContextHIncl
#define ContextHIncl

/*****************************************************************

    c   o   n   t   e   x   t   .   h

*****************************************************************/

#include "expr.h"
#include "verts.h"

class CList : public VertexList
{
public:
    CList();
    void incRefCount();
    int decRefCount();
private:
    int refCount;
};


/*****************************************************************

    C   o   n   t   e   x   t

  expression evaluation context

*****************************************************************/

class Context 
{
public:
    Context();
    ~Context();
    Vertex 
        *current() const;
    void    
        reset();
    Bool 
        isFinished() const;
    Bool
        isVoid() const;
    Vertex 
        *shift();
    void    
        set(Vertex *);
    int
        position;
    Vertex
        *operator[] (int) const;
    void
        deppendall();
    void
        append(Vertex *);
    void
        deppend();
    int
        number() const;
    Context
        *copy();
    Context 
        *swallow(Context *);
    void
        swap(int, int);
protected:
    CList 
        *array;
};

#endif  //ifndef ContextHIncl
