/*
 * Sablotron - XSL processor
 * Copyright (C) 2000 Ginger Alliance Ltd.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef TreeHIncl
#define TreeHIncl

#include "base.h"
#include "verts.h"
#include "datastr.h"

/****************************************
T r e e
****************************************/
class Tree;
// BoolF definition:
//typedef eFlag (Tree::*BoolF)(Vertex*,Tree*,BOOL &);

class Tree /* : public SabObj */
{
public:
    Tree(const Str&, BOOL);
    ~Tree();
    BOOL XSLTree;
    eFlag appendVertex(Vertex *);
    Vertex *popVertex();
    Vertex *appendText(char *, int);
    void output();
    void dump();
    void
        setName(const Str&);
    RootNode root;
    DataLine *dline;
    // Box treeBox;
    Vertex *stackTop;
    Str name;
    NSList pendingNS;
    int
        stripped;
    void dropCurrentElement(Vertex *);
private:
    Text *pendingText;
    int
        vcount;             // # of vertices in tree
};

#endif //ifndef TreeHIncl
