/*
 * Sablotron - XSL processor
 * Copyright (C) 2000 Ginger Alliance Ltd.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef VarsHIncl
#define VarsHIncl

#include "base.h"
#include "datastr.h"
#include "expr.h"

class VarBindingItem /* : public SabObj */
{
public:
    ~VarBindingItem();
    Expression *expr;
    int callLevel, nestLevel;
    Bool prebinding;
};

class VarBindings /* : public SabObj */
{
public:
    VarBindings();
    ~VarBindings();
    QName varname;
    Expression *global;
    PList <VarBindingItem*> bindings;
};

class VarsList : public SList<VarBindings *>
{
public:
    VarsList();
    ~VarsList();
    VarBindings* find(QName&);
    virtual int compare(int, int);
    eFlag addBinding(QName&, Expression *, Bool force);
    eFlag addPrebinding(QName&, Expression *);
    void rmBinding(QName&);
    Expression *getBinding(QName &);
    void startCall();
    void endCall();
    void startNested();
    void endNested();
    void startApplyOne();
    void endApplyOne();
    void rmPrebindings();
    int currCallLevel, currNestLevel;
private:
    VarBindings *getOrAdd(QName &);
    void _endCall(Bool rmLastLevelPrebs);
};

#endif  // ifndef VarsHIncl
